diff --git a/pki/base/common/src/com/netscape/cms/servlet/cert/ChallengeRevocationServlet1.java b/pki/base/common/src/com/netscape/cms/servlet/cert/ChallengeRevocationServlet1.java
index 8ca35484b6ae32b67b17f51f12ae7c684e1698c8..a2b501f143048a5021e177dee6ab64be261797e3 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/cert/ChallengeRevocationServlet1.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/cert/ChallengeRevocationServlet1.java
@@ -339,7 +339,7 @@ public class ChallengeRevocationServlet1 extends CMSServlet {
                 Enumeration<ICertRecord> e = list.getCertRecords(0, totalRecordCount - 1);
 
                 while (e != null && e.hasMoreElements()) {
-                    ICertRecord rec = (ICertRecord) e.nextElement();
+                    ICertRecord rec = e.nextElement();
                     X509CertImpl cert = rec.getCertificate();
                     IArgBlock rarg = CMS.createArgBlock();
 
diff --git a/pki/base/common/src/com/netscape/cms/servlet/cert/DisplayCRL.java b/pki/base/common/src/com/netscape/cms/servlet/cert/DisplayCRL.java
index 3e4a064bab225948943fa41b306823978fbd0dfc..bdaa0df2942309a2a82780d08487b91b3a5875b7 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/cert/DisplayCRL.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/cert/DisplayCRL.java
@@ -216,10 +216,10 @@ public class DisplayCRL extends CMSServlet {
             }
         } else {
             if (crlIssuingPointId != null) {
-                Enumeration ips = mCA.getCRLIssuingPoints();
+                Enumeration<ICRLIssuingPoint> ips = mCA.getCRLIssuingPoints();
 
                 while (ips.hasMoreElements()) {
-                    ICRLIssuingPoint ip = (ICRLIssuingPoint) ips.nextElement();
+                    ICRLIssuingPoint ip = ips.nextElement();
 
                     if (crlIssuingPointId.equals(ip.getId())) {
                         crlIP = ip;
diff --git a/pki/base/common/src/com/netscape/cms/servlet/cert/DoUnrevoke.java b/pki/base/common/src/com/netscape/cms/servlet/cert/DoUnrevoke.java
index edf04b1baccc4427fef6bb0e92217091c7407a48..c5fb568f2d58fb40d54c21db7a8fdaea0d0f2f9c 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/cert/DoUnrevoke.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/cert/DoUnrevoke.java
@@ -410,12 +410,11 @@ public class DoUnrevoke extends CMSServlet {
                 }
 
                 // let known update and publish status of all crls. 
-                Enumeration otherCRLs =
+                Enumeration<ICRLIssuingPoint> otherCRLs =
                         ((ICertificateAuthority) mAuthority).getCRLIssuingPoints();
 
                 while (otherCRLs.hasMoreElements()) {
-                    ICRLIssuingPoint crl = (ICRLIssuingPoint)
-                            otherCRLs.nextElement();
+                    ICRLIssuingPoint crl = otherCRLs.nextElement();
                     String crlId = crl.getId();
 
                     if (crlId.equals(ICertificateAuthority.PROP_MASTER_CRL))
diff --git a/pki/base/common/src/com/netscape/cms/servlet/cert/DoUnrevokeTPS.java b/pki/base/common/src/com/netscape/cms/servlet/cert/DoUnrevokeTPS.java
index edc40613713c938d16e37fe1f7c28c19fb04dc4c..9696198158e9bb429977172533355024a98fdb69 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/cert/DoUnrevokeTPS.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/cert/DoUnrevokeTPS.java
@@ -372,12 +372,11 @@ public class DoUnrevokeTPS extends CMSServlet {
                 }
 
                 // let known update and publish status of all crls. 
-                Enumeration otherCRLs =
+                Enumeration<ICRLIssuingPoint> otherCRLs =
                         ((ICertificateAuthority) mAuthority).getCRLIssuingPoints();
 
                 while (otherCRLs.hasMoreElements()) {
-                    ICRLIssuingPoint crl = (ICRLIssuingPoint)
-                            otherCRLs.nextElement();
+                    ICRLIssuingPoint crl = otherCRLs.nextElement();
                     String crlId = crl.getId();
 
                     if (crlId.equals(ICertificateAuthority.PROP_MASTER_CRL))
diff --git a/pki/base/common/src/com/netscape/cms/servlet/cert/EnrollServlet.java b/pki/base/common/src/com/netscape/cms/servlet/cert/EnrollServlet.java
index 7b3fb2f748d236f7fe34d3ad2a47ac12c83aa6dc..c48cd86353b94fe904920fc917ab5e2d9cff77b0 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/cert/EnrollServlet.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/cert/EnrollServlet.java
@@ -489,7 +489,7 @@ public class EnrollServlet extends CMSServlet {
             boolean encCertFound = false;
 
             while (en.hasMoreElements()) {
-                ICertRecord record = (ICertRecord) en.nextElement();
+                ICertRecord record = en.nextElement();
                 X509CertImpl cert = record.getCertificate();
 
                 // if not encryption cert only, try next one
diff --git a/pki/base/common/src/com/netscape/cms/servlet/cert/GetEnableStatus.java b/pki/base/common/src/com/netscape/cms/servlet/cert/GetEnableStatus.java
index e589cc06c387e7a591c22b10ac8e758e2172cc39..3297c585c0192609a503c29050ce13ff06f7f20d 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/cert/GetEnableStatus.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/cert/GetEnableStatus.java
@@ -149,10 +149,10 @@ public class GetEnableStatus extends CMSServlet {
         header.addStringValue("timeout", "" + timeout);
         header.addStringValue("reqHost", reqHost);
 
-        for (Enumeration hosts = mgr.getHosts(); hosts.hasMoreElements();) {
+        for (Enumeration<String> hosts = mgr.getHosts(); hosts.hasMoreElements();) {
             IArgBlock rarg = CMS.createArgBlock();
 
-            rarg.addStringValue("hosts", (String) hosts.nextElement());
+            rarg.addStringValue("hosts", hosts.nextElement());
             argSet.addRepeatRecord(rarg);
         }
 
diff --git a/pki/base/common/src/com/netscape/cms/servlet/cert/GetInfo.java b/pki/base/common/src/com/netscape/cms/servlet/cert/GetInfo.java
index 7217435a1c24b59a52645c072322b4ef24435f91..ce3b7ee69842da4f58f3ae4d2c91f5cb0c180c04 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/cert/GetInfo.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/cert/GetInfo.java
@@ -265,10 +265,10 @@ public class GetInfo extends CMSServlet {
                 }
 
             } else {
-                Enumeration ips = mCA.getCRLIssuingPoints();
+                Enumeration<ICRLIssuingPoint> ips = mCA.getCRLIssuingPoints();
 
                 while (ips.hasMoreElements()) {
-                    ICRLIssuingPoint ip = (ICRLIssuingPoint) ips.nextElement();
+                    ICRLIssuingPoint ip = ips.nextElement();
 
                     if (ip.isCRLIssuingPointEnabled()) {
                         if (crlIssuingPoints.length() > 0)
diff --git a/pki/base/common/src/com/netscape/cms/servlet/cert/HashEnrollServlet.java b/pki/base/common/src/com/netscape/cms/servlet/cert/HashEnrollServlet.java
index 4d5b711c049520eed21044ecb6fb8d12fbf2e097..1ff056ab781dc692cb320131ff07b549fe8518ca 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/cert/HashEnrollServlet.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/cert/HashEnrollServlet.java
@@ -506,7 +506,7 @@ public class HashEnrollServlet extends CMSServlet {
                     int i = 1;
 
                     while (en.hasMoreElements()) {
-                        ICertRecord record = (ICertRecord) en.nextElement();
+                        ICertRecord record = en.nextElement();
                         X509CertImpl cert = record.getCertificate();
 
                         // if not encryption cert only, try next one
diff --git a/pki/base/common/src/com/netscape/cms/servlet/cert/ListCerts.java b/pki/base/common/src/com/netscape/cms/servlet/cert/ListCerts.java
index 8a818f5e819c4d42f31f6867ddbba86c32916539..b93a82fb8c789c5de0f5fb36faf3f9bb110f0c75 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/cert/ListCerts.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/cert/ListCerts.java
@@ -412,7 +412,7 @@ public class ListCerts extends CMSServlet {
                 toCurIndex = list.getSize() - 1;
             } else {
                 toCurIndex = tolist.getCurrentIndex();
-                ICertRecord rx = (ICertRecord) en.nextElement();
+                ICertRecord rx = en.nextElement();
                 BigInteger curToSerial = rx.getSerialNumber();
 
                 if (curToSerial.compareTo(serialToVal) == -1) {
diff --git a/pki/base/common/src/com/netscape/cms/servlet/cert/Monitor.java b/pki/base/common/src/com/netscape/cms/servlet/cert/Monitor.java
index b248d2bda4c28d80d62f5fdf51111fddf6285ca1..ac531caca5f219107222524d08fa0d68f828ea5f 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/cert/Monitor.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/cert/Monitor.java
@@ -288,7 +288,7 @@ public class Monitor extends CMSServlet {
                 if (mCertDB != null) {
                     filter = Filter(ICertRecord.ATTR_CREATE_TIME, startTime, endTime);
 
-                    Enumeration e = mCertDB.findCertRecs(filter);
+                    Enumeration<Object> e = mCertDB.findCertRecs(filter);
 
                     int count = 0;
 
diff --git a/pki/base/common/src/com/netscape/cms/servlet/cert/UpdateDir.java b/pki/base/common/src/com/netscape/cms/servlet/cert/UpdateDir.java
index 10330501bb042ef46869424d04baa9bc4ee24e54..dc084bd94e963029e433748b4e37465a169ad4fe 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/cert/UpdateDir.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/cert/UpdateDir.java
@@ -416,7 +416,7 @@ public class UpdateDir extends CMSServlet {
                 if (updateValue[VALID_TO].startsWith("0x")) {
                     updateValue[VALID_TO] = hexToDecimal(updateValue[VALID_TO]);
                 }
-                Enumeration validCerts = null;
+                Enumeration<ICertRecord> validCerts = null;
 
                 if (updateValue[CHECK_FLAG] != null &&
                         updateValue[CHECK_FLAG].equalsIgnoreCase("yes")) {
@@ -437,7 +437,7 @@ public class UpdateDir extends CMSServlet {
                 if (validCerts != null) {
                     while (validCerts.hasMoreElements()) {
                         ICertRecord certRecord =
-                                (ICertRecord) validCerts.nextElement();
+                                validCerts.nextElement();
                         //X509CertImpl cert = certRecord.getCertificate();
                         X509CertImpl cert = null;
                         Object o = certRecord.getCertificate();
@@ -534,7 +534,7 @@ public class UpdateDir extends CMSServlet {
                 if (updateValue[EXPIRED_TO].startsWith("0x")) {
                     updateValue[EXPIRED_TO] = hexToDecimal(updateValue[EXPIRED_TO]);
                 }
-                Enumeration expiredCerts = null;
+                Enumeration<ICertRecord> expiredCerts = null;
 
                 if (updateValue[CHECK_FLAG] != null &&
                         updateValue[CHECK_FLAG].equalsIgnoreCase("yes")) {
@@ -554,8 +554,7 @@ public class UpdateDir extends CMSServlet {
 
                 if (expiredCerts != null) {
                     while (expiredCerts.hasMoreElements()) {
-                        ICertRecord certRecord =
-                                (ICertRecord) expiredCerts.nextElement();
+                        ICertRecord certRecord = expiredCerts.nextElement();
                         //X509CertImpl cert = certRecord.getCertificate();
                         X509CertImpl cert = null;
                         Object o = certRecord.getCertificate();
@@ -643,7 +642,7 @@ public class UpdateDir extends CMSServlet {
                 if (updateValue[REVOKED_TO].startsWith("0x")) {
                     updateValue[REVOKED_TO] = hexToDecimal(updateValue[REVOKED_TO]);
                 }
-                Enumeration revokedCerts = null;
+                Enumeration<ICertRecord> revokedCerts = null;
 
                 if (updateValue[CHECK_FLAG] != null &&
                         updateValue[CHECK_FLAG].equalsIgnoreCase("yes")) {
@@ -663,8 +662,7 @@ public class UpdateDir extends CMSServlet {
 
                 if (revokedCerts != null) {
                     while (revokedCerts.hasMoreElements()) {
-                        ICertRecord certRecord =
-                                (ICertRecord) revokedCerts.nextElement();
+                        ICertRecord certRecord = revokedCerts.nextElement();
                         //X509CertImpl cert = certRecord.getCertificate();
                         X509CertImpl cert = null;
                         Object o = certRecord.getCertificate();
diff --git a/pki/base/common/src/com/netscape/cms/servlet/common/AuthCredentials.java b/pki/base/common/src/com/netscape/cms/servlet/common/AuthCredentials.java
index 58c4276e3d9d250d1af83c0f51e96cc99a8c246b..a55406068c74f701dea3416f0d5c33ee03d79def 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/common/AuthCredentials.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/common/AuthCredentials.java
@@ -35,14 +35,14 @@ public class AuthCredentials implements IAuthCredentials {
      *
      */
     private static final long serialVersionUID = -5995164231849154265L;
-    private Hashtable authCreds = null;
+    private Hashtable<String, Object> authCreds = null;
     // Inserted by bskim 
     private IArgBlock argblk = null;
 
     // Insert end
 
     public AuthCredentials() {
-        authCreds = new Hashtable();
+        authCreds = new Hashtable<String, Object>();
     }
 
     /**
@@ -68,7 +68,7 @@ public class AuthCredentials implements IAuthCredentials {
      * @return the named authentication credential
      */
     public Object get(String name) {
-        return ((Object) authCreds.get(name));
+        return authCreds.get(name);
     }
 
     /**
@@ -90,8 +90,8 @@ public class AuthCredentials implements IAuthCredentials {
      * @return an enumeration of the values in this credential set
      * @see java.util.Enumeration
      */
-    public Enumeration getElements() {
-        return (authCreds.elements());
+    public Enumeration<Object> getElements() {
+        return authCreds.elements();
     }
 
     // Inserted by bskim
diff --git a/pki/base/common/src/com/netscape/cms/servlet/common/CMSFileLoader.java b/pki/base/common/src/com/netscape/cms/servlet/common/CMSFileLoader.java
index 9a91cb7295ab6b1d3f183d1ab1bdf2ff712387e7..808bdda78b66b2356063dcb8ee03416e4039d79c 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/common/CMSFileLoader.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/common/CMSFileLoader.java
@@ -44,7 +44,7 @@ public class CMSFileLoader {
     public final String PROP_CACHE_TEMPLATES_ONLY = "cacheTemplatesOnly";
 
     // hash of files to their content. 
-    private Hashtable mLoadedFiles = new Hashtable();
+    private Hashtable<String, CMSFile> mLoadedFiles = new Hashtable<String, CMSFile>();
 
     // max number of files 
     private int mMaxSize = MAX_SIZE;
@@ -141,14 +141,14 @@ public class CMSFileLoader {
 
         // remove the LRU files.
         // XXX could be optimized more.
-        Enumeration elements = mLoadedFiles.elements();
+        Enumeration<CMSFile> elements = mLoadedFiles.elements();
 
         for (int i = mClearSize; i > 0; i--) {
             long lru = java.lang.Long.MAX_VALUE;
             CMSFile lruFile = null;
 
             while (elements.hasMoreElements()) {
-                CMSFile cmsFile = (CMSFile) elements.nextElement();
+                CMSFile cmsFile = elements.nextElement();
 
                 if (cmsFile.getLastAccess() < lru) {
                     lruFile = cmsFile;
diff --git a/pki/base/common/src/com/netscape/cms/servlet/common/CMSGateway.java b/pki/base/common/src/com/netscape/cms/servlet/common/CMSGateway.java
index 74d46badf4b91c88b6a7a70983a028191455a185..d04e2fb22933c381c05e8ce0ca4a9e4b72429d4d 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/common/CMSGateway.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/common/CMSGateway.java
@@ -79,10 +79,10 @@ public class CMSGateway {
 
     public static Hashtable toHashtable(HttpServletRequest req) {
         Hashtable httpReqHash = new Hashtable();
-        Enumeration names = req.getParameterNames();
+        Enumeration<String> names = req.getParameterNames();
 
         while (names.hasMoreElements()) {
-            String name = (String) names.nextElement();
+            String name = names.nextElement();
 
             httpReqHash.put(name, req.getParameter(name));
         }
diff --git a/pki/base/common/src/com/netscape/cms/servlet/common/CMSRequest.java b/pki/base/common/src/com/netscape/cms/servlet/common/CMSRequest.java
index 822d8a0d8563ceadbeae6d2a2ffb9133e840f09e..b1be4f7a57a58f4947f9020ad9d211665c5fce66 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/common/CMSRequest.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/common/CMSRequest.java
@@ -78,7 +78,7 @@ public class CMSRequest {
     private String mError = null;
 
     // any error description.
-    private Vector mErrorDescr = null;
+    private Vector<String> mErrorDescr = null;
 
     // any request resulting data;
     Object mResult = null;
@@ -170,7 +170,7 @@ public class CMSRequest {
 
     public void setErrorDescription(String descr) {
         if (mErrorDescr == null)
-            mErrorDescr = new Vector();
+            mErrorDescr = new Vector<String>();
         mErrorDescr.addElement(descr);
     }
 
@@ -215,7 +215,7 @@ public class CMSRequest {
         return mError;
     }
 
-    public Vector getErrorDescr() {
+    public Vector<String> getErrorDescr() {
         return mErrorDescr;
     }
 
diff --git a/pki/base/common/src/com/netscape/cms/servlet/common/GenErrorTemplateFiller.java b/pki/base/common/src/com/netscape/cms/servlet/common/GenErrorTemplateFiller.java
index 1c7d61c9ad15aeb9051bd980844f7356a59bec05..40edb3bda1b6f9aa930e3c0b354f7fa056dae90b 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/common/GenErrorTemplateFiller.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/common/GenErrorTemplateFiller.java
@@ -77,13 +77,13 @@ public class GenErrorTemplateFiller implements ICMSTemplateFiller {
         // Change end
 
         // error description if any.
-        Vector descr = cmsReq.getErrorDescr();
+        Vector<String> descr = cmsReq.getErrorDescr();
 
         if (descr != null) {
-            Enumeration num = descr.elements();
+            Enumeration<String> num = descr.elements();
 
             while (num.hasMoreElements()) {
-                String elem = (String) num.nextElement();
+                String elem = num.nextElement();
                 //System.out.println("Setting description "+elem.toString());
                 IArgBlock argBlock = CMS.createArgBlock();
 
diff --git a/pki/base/common/src/com/netscape/cms/servlet/common/GenRejectedTemplateFiller.java b/pki/base/common/src/com/netscape/cms/servlet/common/GenRejectedTemplateFiller.java
index 3dde11475c26dc85533906e9cceac2ad603131b6..9e75cc7996260000ee1207cdf0b4c2b251b2b18c 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/common/GenRejectedTemplateFiller.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/common/GenRejectedTemplateFiller.java
@@ -67,13 +67,13 @@ public class GenRejectedTemplateFiller implements ICMSTemplateFiller {
             fixed.set(ICMSTemplateFiller.REQUEST_ID, req.getRequestId());
 
             // policy errors (rejection reasons)
-            Vector messages = req.getExtDataInStringVector(IRequest.ERRORS);
+            Vector<String> messages = req.getExtDataInStringVector(IRequest.ERRORS);
 
             if (messages != null) {
-                Enumeration msgs = messages.elements();
+                Enumeration<String> msgs = messages.elements();
 
                 while (msgs.hasMoreElements()) {
-                    String ex = (String) msgs.nextElement();
+                    String ex = msgs.nextElement();
                     IArgBlock messageArgBlock = CMS.createArgBlock();
 
                     messageArgBlock.set(POLICY_MESSAGE, ex);
diff --git a/pki/base/common/src/com/netscape/cms/servlet/csadmin/BaseServlet.java b/pki/base/common/src/com/netscape/cms/servlet/csadmin/BaseServlet.java
index 9bb81902f43fbd9f3222fea2c9855e741a5781a9..f619110fd93202a8dc45404b493c1722ea4865a7 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/csadmin/BaseServlet.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/csadmin/BaseServlet.java
@@ -60,10 +60,10 @@ public class BaseServlet extends VelocityServlet {
 
     public void outputHttpParameters(HttpServletRequest httpReq) {
         CMS.debug("BaseServlet:service() uri = " + httpReq.getRequestURI());
-        Enumeration paramNames = httpReq.getParameterNames();
+        Enumeration<String> paramNames = httpReq.getParameterNames();
 
         while (paramNames.hasMoreElements()) {
-            String pn = (String) paramNames.nextElement();
+            String pn = paramNames.nextElement();
             // added this facility so that password can be hidden,
             // all sensitive parameters should be prefixed with 
             // __ (double underscores); however, in the event that
diff --git a/pki/base/common/src/com/netscape/cms/servlet/csadmin/CertRequestPanel.java b/pki/base/common/src/com/netscape/cms/servlet/csadmin/CertRequestPanel.java
index c81c666e6f37c096bc1df8c072d5f575c4734a44..43c707fbea76c6407f6727d542efc519b63fe952 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/csadmin/CertRequestPanel.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/csadmin/CertRequestPanel.java
@@ -54,7 +54,7 @@ import com.netscape.cms.servlet.wizard.WizardServlet;
 import com.netscape.cmsutil.crypto.CryptoUtil;
 
 public class CertRequestPanel extends WizardPanelBase {
-    private Vector mCerts = null;
+    private Vector<Cert> mCerts = null;
     private WizardServlet mServlet = null;
 
     public CertRequestPanel() {
@@ -386,7 +386,7 @@ public class CertRequestPanel extends WizardPanelBase {
         context.put("title", "Requests and Certificates");
 
         try {
-            mCerts = new Vector();
+            mCerts = new Vector<Cert>();
 
             IConfigStore config = CMS.getConfigStore();
 
@@ -499,7 +499,7 @@ public class CertRequestPanel extends WizardPanelBase {
         }
 
         try {
-            Enumeration c = mCerts.elements();
+            Enumeration<Cert> c = mCerts.elements();
 
             String tokenname = "";
             try {
diff --git a/pki/base/common/src/com/netscape/cms/servlet/csadmin/ConfigBaseServlet.java b/pki/base/common/src/com/netscape/cms/servlet/csadmin/ConfigBaseServlet.java
index 5ae9bada83d819f859c06ac7f09ca47467579df7..dbda788f62dc362e2e55cc78d5deae0630d18d2f 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/csadmin/ConfigBaseServlet.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/csadmin/ConfigBaseServlet.java
@@ -57,10 +57,11 @@ public abstract class ConfigBaseServlet extends BaseServlet {
 
     public void outputHttpParameters(HttpServletRequest httpReq) {
         CMS.debug("ConfigBaseServlet:service() uri = " + httpReq.getRequestURI());
-        Enumeration paramNames = httpReq.getParameterNames();
+        @SuppressWarnings("unchecked")
+        Enumeration<String> paramNames = httpReq.getParameterNames();
 
         while (paramNames.hasMoreElements()) {
-            String pn = (String) paramNames.nextElement();
+            String pn = paramNames.nextElement();
             // added this facility so that password can be hidden,
             // all sensitive parameters should be prefixed with 
             // __ (double underscores); however, in the event that
diff --git a/pki/base/common/src/com/netscape/cms/servlet/csadmin/ConfigHSMServlet.java b/pki/base/common/src/com/netscape/cms/servlet/csadmin/ConfigHSMServlet.java
index 9428ecce0467f61eee864707d2d50fda961df693..ba56505427bd5b931596e908b0aa6b90c2335a6a 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/csadmin/ConfigHSMServlet.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/csadmin/ConfigHSMServlet.java
@@ -44,10 +44,10 @@ public class ConfigHSMServlet extends ConfigBaseServlet {
      */
     private static final long serialVersionUID = -330521231753992202L;
     private CryptoManager mCryptoManager = null;
-    private Vector mSupportedModules = null;
+    private Vector<Module> mSupportedModules = null;
     private Vector mOtherModules = null;
     private String mDefaultTok = null;
-    private Hashtable mCurrModTable = new Hashtable();
+    private Hashtable<String, PK11Module> mCurrModTable = new Hashtable<String, PK11Module>();
 
     public void init(ServletConfig config) throws ServletException {
         super.init(config);
@@ -57,10 +57,11 @@ public class ConfigHSMServlet extends ConfigBaseServlet {
         try {
             // getting existing modules
             mCryptoManager = CryptoManager.getInstance();
-            Enumeration modules = mCryptoManager.getModules();
+            @SuppressWarnings("unchecked")
+            Enumeration<PK11Module> modules = mCryptoManager.getModules();
 
             while (modules.hasMoreElements()) {
-                PK11Module mod = (PK11Module) modules.nextElement();
+                PK11Module mod = modules.nextElement();
 
                 CMS.debug("ConfigHSMServlet: got module " + mod.getName());
                 mCurrModTable.put(mod.getName(), mod);
@@ -77,16 +78,16 @@ public class ConfigHSMServlet extends ConfigBaseServlet {
      * Modules not listed as supported modules
      */
     public void loadOtherModules() {
-        Enumeration m = mCurrModTable.elements();
+        Enumeration<PK11Module> m = mCurrModTable.elements();
 
         mOtherModules = new Vector();
         while (m.hasMoreElements()) {
-            PK11Module mod = (PK11Module) m.nextElement();
-            Enumeration s = mSupportedModules.elements();
+            PK11Module mod = m.nextElement();
+            Enumeration<Module> s = mSupportedModules.elements();
             boolean found = false;
 
             while (s.hasMoreElements()) {
-                Module sm = (Module) s.nextElement();
+                Module sm = s.nextElement();
 
                 if (mod.getName().equals(sm.getCommonName())) {
                     found = true;
@@ -111,11 +112,12 @@ public class ConfigHSMServlet extends ConfigBaseServlet {
      * find all tokens belonging to a module and load the Module
      */
     public void loadModTokens(Module module, PK11Module mod) {
-        Enumeration tokens = mod.getTokens();
+        @SuppressWarnings("unchecked")
+        Enumeration<CryptoToken> tokens = mod.getTokens();
 
         while (tokens.hasMoreElements()) {
             try {
-                CryptoToken token = (CryptoToken) tokens.nextElement();
+                CryptoToken token = tokens.nextElement();
 
                 CMS.debug("ConfigHSMServlet: token nick name=" + token.getName());
                 CMS.debug(
@@ -145,7 +147,7 @@ public class ConfigHSMServlet extends ConfigBaseServlet {
 
         // getting supported security modules
         // a Vectgor of Modules
-        mSupportedModules = new Vector();
+        mSupportedModules = new Vector<Module>();
         // read from conf store all supported modules
         try {
             int count = CMS.getConfigStore().getInteger(
@@ -172,7 +174,7 @@ public class ConfigHSMServlet extends ConfigBaseServlet {
                     CMS.debug("ConfigHSMServlet: module found: " + cn);
                     module.setFound(true);
                     // add token info to module vector
-                    PK11Module m = (PK11Module) mCurrModTable.get(cn);
+                    PK11Module m = mCurrModTable.get(cn);
 
                     loadModTokens(module, m);
                 }
@@ -180,7 +182,7 @@ public class ConfigHSMServlet extends ConfigBaseServlet {
                 CMS.debug("ConfigHSMServlet: adding module " + cn);
                 // add module to set
                 if (!mSupportedModules.contains(module)) {
-                    mSupportedModules.addElement((Object) module);
+                    mSupportedModules.addElement(module);
                 }
             }// for
 
diff --git a/pki/base/common/src/com/netscape/cms/servlet/csadmin/DatabasePanel.java b/pki/base/common/src/com/netscape/cms/servlet/csadmin/DatabasePanel.java
index 02a99283273462e2bea248d23e97e4526f82f5db..6cafe973691cbdf4fb08f507706f66b9168e3394 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/csadmin/DatabasePanel.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/csadmin/DatabasePanel.java
@@ -1467,9 +1467,10 @@ public class DatabasePanel extends WizardPanelBase {
             LDAPEntry entry = results.next();
             LDAPAttribute attr = entry.getAttribute("nsds5replicalastinitstatus");
             if (attr != null) {
-                Enumeration valsInAttr = attr.getStringValues();
+                @SuppressWarnings("unchecked")
+                Enumeration<String> valsInAttr = attr.getStringValues();
                 if (valsInAttr.hasMoreElements()) {
-                    return (String) valsInAttr.nextElement();
+                    return valsInAttr.nextElement();
                 } else {
                     throw new IOException("No value returned for nsds5replicalastinitstatus");
                 }
@@ -1496,14 +1497,16 @@ public class DatabasePanel extends WizardPanelBase {
                 String dn = entry.getDN();
                 CMS.debug("DatabasePanel getInstanceDir: DN for storing nsslapd-directory: " + dn);
                 LDAPAttributeSet entryAttrs = entry.getAttributeSet();
-                Enumeration attrsInSet = entryAttrs.getAttributes();
+                @SuppressWarnings("unchecked")
+                Enumeration<LDAPAttribute> attrsInSet = entryAttrs.getAttributes();
                 while (attrsInSet.hasMoreElements()) {
-                    LDAPAttribute nextAttr = (LDAPAttribute) attrsInSet.nextElement();
+                    LDAPAttribute nextAttr = attrsInSet.nextElement();
                     String attrName = nextAttr.getName();
                     CMS.debug("DatabasePanel getInstanceDir: attribute name: " + attrName);
-                    Enumeration valsInAttr = nextAttr.getStringValues();
+                    @SuppressWarnings("unchecked")
+                    Enumeration<String> valsInAttr = nextAttr.getStringValues();
                     while (valsInAttr.hasMoreElements()) {
-                        String nextValue = (String) valsInAttr.nextElement();
+                        String nextValue = valsInAttr.nextElement();
                         if (attrName.equalsIgnoreCase("nsslapd-directory")) {
                             CMS.debug("DatabasePanel getInstanceDir: instanceDir=" + nextValue);
                             return nextValue.substring(0, nextValue.lastIndexOf("/db"));
